!
! Copyright (c) 2000-2013,2017 Yoshihide Yoshimoto
! 
program main
  implicit none
  integer,parameter:: nfin = 10, nfout = 11
  real(kind=8),parameter:: oneau = 0.529177249
  integer:: nrx2, nry2, nrz2, nspin
  real(kind=8):: aa(3,3)
  character(len=256):: ifname, argv(4)
  real(kind=8),allocatable:: field(:,:,:,:)
  character(len=8),parameter:: magic = 'TAPP:rho'
  character(len=8):: sign
  integer:: ic, i, i3, is, ios
  real(kind=8):: rhomax(2), rhomin(2), rhosrf(2)
  real(kind=8):: h(3),dz,area

  ic = 1
  call getarg(ic, argv(ic))
  if (len_trim(argv(ic)) .eq. 0) then
     write(6,*) 'invalid fname'
     stop
  end if
  ifname = argv(ic)
  open(nfin, file=ifname, status='old', action='read', form='unformatted')
  ic = ic + 1
  do i = ic, ic + 2
     call getarg(i, argv(i))
  end do

  rewind nfin
  read(nfin) sign
  if (sign .ne. magic) then
     write(6,*) 'bad magic: ', sign
     stop
  end if
  read(nfin, iostat=ios) aa, nspin
  if (ios.ne.0) then
     nspin = 1
     backspace(nfin)
     read(nfin) aa
  end if
  read(nfin) nrx2, nry2, nrz2
  allocate(field(nrx2,nry2,nrz2,nspin))
  read(nfin) field

  h(1) = aa(2,1)*aa(3,2)-aa(3,1)*aa(2,2)
  h(2) = aa(3,1)*aa(1,2)-aa(1,1)*aa(3,2)
  h(3) = aa(1,1)*aa(2,2)-aa(2,1)*aa(1,2)
  area = sqrt(h(1)*h(1)+h(2)*h(2)+h(3)*h(3))
  h = h/area
  dz = h(1)*aa(1,3)+h(2)*aa(2,3)+h(3)*aa(3,3)
  dz = abs(dz/nrz2)

  if (nspin.eq.1) then
     write(6,'(1x,a)') '# z, rhomax, rhomin, rhomax-rhomin, rhosrf'
  else
     write(6,'(1x,a,a)') '# z, rhomax(1), rhomin(1),', &
          ' rhomax(1)-rhomin(1), rhosrf(1),', &
          ' rhomin(2), rhomin(2), rhomax(2)-rhomin(2), rhosrf(2)'
  end if
  write(6,'(1x,a,e13.6)') '# area = ', area
  do i3=1,nrz2
     do is=1,nspin
        rhomax(is) = maxval(field(:,:,i3,is))
        rhomin(is) = minval(field(:,:,i3,is))
        rhosrf(is) = sum(field(:,:,i3,is))*area/nrx2/nry2
     end do
     if (nspin.eq.1) then
        write(6,'(1x,f9.5,4(1x,e13.6))') dz*(i3-1), &
             rhomax(1), rhomin(1), rhomax(1)-rhomin(1), rhosrf(1)
     else
        write(6,'(1x,f9.5,8(1x,e13.6))') dz*(i3-1), &
             rhomax(1), rhomin(1), rhomax(1)-rhomin(1), rhosrf(1), &
             rhomax(2), rhomin(2), rhomax(2)-rhomin(2), rhosrf(2)
     end if
  end do
  stop
end program main
