C
C
C Copyright (c) 1983-2000 TAPP Consortium
C Copyright (c) 2013 Yoshihide Yoshimoto
C 
      subroutine latgen(ax,bx,aa,bb,va,vb,mssg)
      implicit real*8(a-h,o-z)
      dimension aa(3,3),bb(3,3)
      integer mssg
      data p2/6.28318530717958648d0/

      v=aa(1,1)*(aa(2,2)*aa(3,3)-aa(3,2)*aa(2,3))
     & +aa(2,1)*(aa(3,2)*aa(1,3)-aa(1,2)*aa(3,3))
     & +aa(3,1)*(aa(1,2)*aa(2,3)-aa(2,2)*aa(1,3))

      va=abs(v)*ax**3
      bx=p2/ax
      w=v/p2/ax
      bb(1,1)=(aa(2,2)*aa(3,3)-aa(3,2)*aa(2,3))/w
      bb(2,1)=(aa(3,2)*aa(1,3)-aa(1,2)*aa(3,3))/w
      bb(3,1)=(aa(1,2)*aa(2,3)-aa(2,2)*aa(1,3))/w
      bb(1,2)=(aa(2,3)*aa(3,1)-aa(3,3)*aa(2,1))/w
      bb(2,2)=(aa(3,3)*aa(1,1)-aa(1,3)*aa(3,1))/w
      bb(3,2)=(aa(1,3)*aa(2,1)-aa(2,3)*aa(1,1))/w
      bb(1,3)=(aa(2,1)*aa(3,2)-aa(3,1)*aa(2,2))/w
      bb(2,3)=(aa(3,1)*aa(1,2)-aa(1,1)*aa(3,2))/w
      bb(3,3)=(aa(1,1)*aa(2,2)-aa(2,1)*aa(1,2))/w
      v=bb(1,1)*(bb(2,2)*bb(3,3)-bb(3,2)*bb(2,3))
     & +bb(2,1)*(bb(3,2)*bb(1,3)-bb(1,2)*bb(3,3))
     & +bb(3,1)*(bb(1,2)*bb(2,3)-bb(2,2)*bb(1,3))
      vb=abs(v)/ax**3
C
      return
      end
c***********************************************************************
      subroutine mvint(s,nc,idat,ier)
C     ================================================================
C     mvint -- extracts an integer from a string
C              v1.0 1996.11.9 Y.Suwa
C     ----------------------------------------------------------------
C     in:  s(nc).. string, only spaces are allowed before the integer
C     out: idat .. extracted integer. if error, unchanged.
C          s(nc).. extracted columns are filled with spaces.
C                  if error, unchanged.
C          ier  .. error status, 0=normal, 1=no integer, 
C                  2=integer ends with non space character,
C                  3=reached end of string.
C     ================================================================
C
      character*1 s(nc)
      character*1 cha(0:9)
      data cha/'0','1','2','3','4','5','6','7','8','9'/
      ier=0
      itmp=0
C
C     -- skip spaces
      do 100 ii=1,nc
        if (s(ii).ne.' ') goto 200
  100 continue
C     -- only spaces in string.
      ier=1
      return
  200 continue
C
C     -- read [+-] if exist
C     -- idat is multiplied by isig afterwards.
      isig=1
      if (s(ii).eq.'-') then
        isig=-1
        ii=ii+1
      else if (s(ii).eq.'+') then
        ii=ii+1
      endif
C
C     -- read [0-9]
C     -- iany=1 if any number is obtained.
      iany=0
      do 300 i=ii,nc
        do 400 j=0,9
          if (s(i).eq.cha(j)) then
            itmp=itmp*10+j
            iany=1
            goto 300
          endif
  400   continue
C       -- here, end of integer is detected.
        goto 600
  300 continue
C     -- here, input string ends while [0-9] continues.
      ier=3
      return
C
  600 continue
      if (iany.eq.0) then
C        -- no integer is obtained.
        ier=1
        return
      endif
      if (s(i).ne.' ') then
C       -- integer ends with non space characters.
        ier=2
        return
      endif
C
C     -- here, integer is obtained correctly.
C     -- extracted columns are filled with spaces
      do 500 k=1,i-1
        s(k)=' '
  500 continue
C     -- obtained integer
      idat=itmp*isig
      return
      end
C
      subroutine mvdbl(s,nc,ddat,ier)
C     ===============================================================
C     mvdbl -- extracts a real*8 from a string
C              v1.0 1996.11.9 Y.Suwa
C     ---------------------------------------------------------------
C     in:  s(nc).. string, only spaces are allowed before the number
C     out: idat .. extracted real*8. if error, unchanged.
C          s(nc).. extracted columns are filled with spaces.
C                  if error, unchanged.
C          ier  .. error status, 0=normal, 1=no number, 
C                  2=number ends with non space character,
C                  3=reached end of string, 4=two decimal points,
C                  5=exponent part error.
C     ===============================================================
      real*8 ddat,dtmp
      character*1 s(nc)
      character*1 cha(0:13)
      data cha/'0','1','2','3','4','5','6','7','8','9',
     &         'e','E','d','D'/
      ier=0
      iex=0
      dtmp=0.d0
C
C     -- skip spaces
      do 100 ii=1,nc
        if (s(ii).ne.' ') goto 200
  100 continue
C     -- only spaces in string.
      ier=1
      return
  200 continue
C
C     -- read [+-] if exist
C     -- idat is multiplied by isig afterwards.
      isig=1
      if (s(ii).eq.'-') then
        isig=-1
        ii=ii+1
      else if (s(ii).eq.'+') then
        ii=ii+1
      endif
C
C     -- read [0-9.]
C     -- iany=1 if any number is obtained.
      iany=0
      idot=0
      l=0
      do 300 i=ii,nc
C       -- check [0-9]
        do 400 j=0,9
          if (s(i).eq.cha(j)) then
            iany=1
            if (idot.eq.0) then
C             -- before decimal point
              dtmp=dtmp*10.d0+dble(j)
            else
C             -- after decimal point
              l=l+1
              dtmp=dtmp+dble(j)*0.1d0**l
            endif
            goto 300
          endif
  400   continue
C       -- check [.]
        if (s(i).eq.'.') then
          if (idot.eq.0) then
            idot=1
            goto 300
          else
C           -- 2nd [.] is detected.
            ier=4
            return
          endif
        endif
C       -- here, end of number (except exponent) is detected.
        goto 600
  300 continue
C     -- here, input string ends while [0-9.] continues.
      ier=3
      return
C     
  600 continue
      if (iany.eq.0) then
C       -- no munber is obtained.
        ier=1
        return
      endif
C
C     -- check exponent
      if (s(i).eq.'e'.or.s(i).eq.'E'.or.s(i).eq.'d'.or.s(i).eq.'D') then
        if (s(i+1).eq.' ') then
C         -- spaces after [e] is not allowed.
          ier=2
          return
        endif
        call mvint(s(i+1),nc-i,iex,ir)
        if (ir.ne.0) then
C         -- failed to etract exponent part
          ier=5
          return
        endif
        s(i)=' '
      endif
C
C     -- check non space characters
      if (s(i).ne.' ') then
        ier=3
        return
      endif
C
C     -- here, number is obtained correctly.
C     -- extracted columns are filled with spaces.
      do 500 k=1,i
        s(k)=' '
  500 continue
C     -- obtained number
      ddat=dble(isig)*dtmp*10.d0**iex
      return
      end
c***********************************************************************
      subroutine getint(cstr,nstr,idat,nidat)
C     ---------------------------------------------------------------
C     getint -- extracts unknown number of integer data from a string
C               1995.5.23 Y.Suwa
C     input: cstr(nstr) .. character array.
C            data should be 0 or positive integers (without '+') and
C            should be separeted by one or more spaces.
C     output: idat(nidat) .. integer array
C             maximum number of integer data is nidat.
C             idat(i) >= 0  obtained data
C             idat(i) = -1  i-th data is not obtained
C     ---------------------------------------------------------------
C
      character*1 cstr(nstr)
      integer idat(nidat)
      character*1 cha(0:9)
      data cha/'0','1','2','3','4','5','6','7','8','9'/
C
C     -- clear data
      do 400 i=1,nidat
        idat(i)=-1
  400 continue
C
      i=0
      ispc=1
      do 100 j=1,nstr
        if (cstr(j).eq.' ') then
          ispc=1
C         -- if maxnum of data are obtained, exit
          if (i.ge.nidat) goto 300
          goto 100
        endif
        do 200 k=0,9
          if (cstr(j).eq.cha(k)) then
            if (ispc.eq.0) then
              idat(i)=idat(i)*10+k
            else
              ispc=0
              i=i+1
              idat(i)=k
            endif
            goto 100
          endif
  200   continue
C       -- arriving here means [^0-9 ], i.e., data area is ended.
        goto 300
  100 continue
C     -- exitting
  300 continue
      return
      end
