#! /usr/bin/python
# Copyright (c) 2015 Yoshihide Yoshimoto

import yaml
import numpy as np
import math

banddotyaml = open('band.yaml').read()
data = yaml.load(banddotyaml)

natom = data['natom']

qlen = 0.0
qprev = np.array(data['phonon'][0]['q-position']);

for ph in data['phonon']:
   q = np.array(ph['q-position'])
   dq = q - qprev
   qlen = qlen + math.sqrt(dq[0]*dq[0]+dq[1]*dq[1]+dq[2]*dq[2])
   print " {0:13.10f} {1:13.10f} {2:13.10f}".format(q[0],q[1],q[2]),
   print "{0:13.10f}".format(qlen),
   for bnd in ph['band']:
       print "{0:13.10f}".format(bnd['frequency']),
   print
   qprev = q
